--region CookRoadLayer.lua
--Author : Jackie
--Date   : 2014/9/22
--此文件由[BabeLua]插件自动生成

require("luaScript/apiRequest")
require("luaScript/smartRes")
require("luaScript/Utils");
require("luaScript/petFightLayer")
local roadLayer = nil;
local contentLayer = nil;
local stageLayer = nil;
--本层一些基本参数
local roadLayerSettings ={
--测试环境
debugEnv = false;
--本层优先级
priority_roadLayer= gIntMin + 100,
--本层zorder
zOrder_roadLayer = 100,
--当前关卡箭头
zOrder_arrow = 10000,
--本层按钮优先级
priority_btn = gIntMin + 99,

                          };
-----------------------------------------------关卡情况
local words = {
    box_not = "请通关前置关卡",--不能打的关卡
    box_already = "该宝箱已被打开",--已经通关的关卡
    stage_not = "请通关前置关卡",--不能领取的箱子
    stage_already = "该副本已通关"--已经领取的箱子
}
local stageType = {
                     stage_normal=1,--普通关卡
                     stage_boss = 2,--箱子奖励前关卡
                     stage_box_1 = 3,--奖励1
                     stage_box_2 = 4,--奖励2
                     stage_box_3 = 5,--奖励3
                     stage_box_4 = 6,--奖励4
                    }

--关卡地图配置
local stageInfo = 
{
    {pos = ccp(42.0,341.5), sType=stageType["stage_normal"],id=1},   {pos = ccp(75.0,419.5), sType=stageType["stage_normal"],id=2},   {pos = ccp(172.0,454.0),sType=stageType["stage_boss"],id=3},   {pos = ccp(262.0,434.0),sType=stageType["stage_box_1"],id=1},
    {pos = ccp(328.0,392.5),sType=stageType["stage_normal"],id=4},   {pos = ccp(398.0,366.5),sType=stageType["stage_normal"],id=5},   {pos = ccp(502.0,415.0),sType=stageType["stage_boss"],id=6},   {pos = ccp(592.0,483.0),sType=stageType["stage_box_2"],id=2},
    {pos = ccp(687.0,461.5),sType=stageType["stage_normal"],id=7},   {pos = ccp(739.0,418.5),sType=stageType["stage_normal"],id=8},   {pos = ccp(765.0,320.0),sType=stageType["stage_boss"],id=9},   {pos = ccp(725.0,238.0),sType=stageType["stage_box_3"],id=3},
    {pos = ccp(663.0,208.5),sType=stageType["stage_normal"],id=10},   {pos = ccp(580.0,198.5),sType=stageType["stage_normal"],id=11},   {pos = ccp(502.0,205.0),sType=stageType["stage_boss"],id=12},   {pos = ccp(409.0,260.0),sType=stageType["stage_box_3"],id=4},
    {pos = ccp(331.0,281.5),sType=stageType["stage_normal"],id=13},   {pos = ccp(276.0,247.5),sType=stageType["stage_normal"],id=14},   {pos = ccp(224.0,179.0),sType=stageType["stage_boss"],id=15},   {pos = ccp(096.0,195.0),sType=stageType["stage_box_4"],id=5},
};
--关卡数量
local stageNum = 20;
--当前到了第几个关卡
local curStage = 1;

-----------------------------------------------

local function debugEnv()
    return roadLayerSettings["debugEnv"];
end


--成功获取信息后的执行的回调，失败后执行的回调
local tmpOkCallback = nil;
local function requestInfoCallback(ret)
    if debugEnv() then
        print("cookRoadLayer:requestInfo:",ret);
    end
    local stRet = JSON:decode(ret);
    if stRet["ret"] ~= 0 or not stRet["body"] or not stRet["body"]["expedition"] then return end
    --当前关卡
    curStage = stRet["body"]["expedition"]["maxpoint"] + 1;
    local boxNum = 0;
    if stRet["body"]["expedition"]["boxid"] then 
        for i,v in pairs(stRet["body"]["expedition"]["boxid"]) do
            boxNum = boxNum+1;
        end
    end
    curStage = curStage +boxNum
    if tmpOkCallback then tmpOkCallback() end;
end
local function requestInfo(okCallback)
    tmpOkCallback = okCallback;
    local req = {cmd = "expedition",method="GetInfo"};
    luaApiRequest(req, requestInfoCallback);
end

local function updateMap()
    requestInfo(initCookRoadView);
end
local function openBoxCallback(ret)
    if debugEnv() then
        print("openBoxCallback:",ret)
    end
    local stRet = JSON:decode(ret);
    if not stRet or stRet["ret"] ~= 0 then return end
    if stRet["consum"] and stRet["consum"]["goods"] then
        local drops = stRet["consum"]["goods"];
        DropLayer:getInstance():showIn(roadLayer,JSON:encode(drops),CCCallFunc:create(updateMap));
        return;
    end
    updateMap();
end
--开宝箱
local function MenuCallback_OpenBox(id,sender)
    local stReq = {cmd="expedition",method="OpenBox",boxid=id}
    luaApiRequest(stReq, openBoxCallback)
end
local function fightEndCallback(ret)
    if debugEnv() then
        print("fightEndCallback:");
    end
    local stRet = JSON:decode(ret);
    if stRet and stRet["ret"] == 0 and stRet["consum"] then
        local stRet = JSON:decode(ret);
        local drops = stRet["consum"]["goods"];
        DropLayer:getInstance():showIn(roadLayer,JSON:encode(drops),CCCallFunc:create(updateMap));
        return
    end;
    updateMap();
end

--战斗结束回调
local function fightEnd(result)
    local req={cmd="expedition",method="EndExpedition",point=stageInfo[curStage]["id"],isWin=0};
    if result == "win" then 
        req["isWin"] = 1;
    end
    luaApiRequest(req, fightEndCallback)
end

local function startFightCallback(ret)
    if debugEnv() then
        print("startFightCallback:",ret);
    end
    local stRet = JSON:decode(ret);
    if stRet["ret"] ~= 0 then return end;

    local fightInfo = {self={attr={},map={}},enemy={attr={},map={}}};

    fightInfo["self"]["attr"] = getUserInfo("attr")
    fightInfo["self"]["map"] = getUserInfo("map")
    fightInfo["enemy"]["attr"] = stRet["body"]["userinfo"]["attr"];
    fightInfo["enemy"]["map"] = stRet["body"]["userinfo"]["map"];
    
    if fightInfo["self"]["map"]["pet"]["zdl"]["zdl_sum"]<fightInfo["enemy"]["map"]["pet"]["zdl"]["zdl_sum"] then
        local strStage = string.format("%d",stageInfo[curStage].id)
        local delow = getConf("config/expedition_config.txt")

		--fightInfo["self"]["map"]["pet"]["atk_mul"] = tmpGameInfo["npcinfo"]["boss"]["playeratk"].asFloat();
		fightInfo["enemy"]["map"]["pet"]["atk_mul"] = delow["expedition"]["delow"];
    end
    createFightLayer(CCDirector:sharedDirector():getRunningScene(), JSON:encode(fightInfo), 4, fightEnd)
end

local function enoughToFight()
    local req={cmd="expedition",method="StartExpedition",point=stageInfo[curStage].id}
    luaApiRequest(req, startFightCallback)
end
local function notEnoughtToFight()
end

local function MenuCallback_Fight(id,sender)
    local itemNeed = {};
    local conf = getConf("config/expedition_config.txt")
    if conf["expedition"] and conf["expedition"][tostring(id)] then
        local conf_1 = conf["expedition"][tostring(id)]
        if conf_1["add1"] and conf_1["add1"]["egy"] then
            if conf_1["add1"]["egy"] < 0 and CUserData:getInstance():getGoodsNumById("egy")+conf_1["add1"]["egy"] >=0  then
                enoughToFight(); 
            else                
                TopMenu:getInstance():addEgyCallBack(nil);
            end 
        end
    end
end

local function MenuCallback_ClickBoxNot()
    CAlertLayer:getInstance():showAlert(roadLayer,words.box_not);
end
local function MenuCallback_ClickBoxGot()
    CAlertLayer:getInstance():showAlert(roadLayer,words.box_already);
end
local function MenuCallback_ClickStageNot()
    CAlertLayer:getInstance():showAlert(roadLayer,words.stage_not);
end
local function MenuCallback_ClickStageGot()
    CAlertLayer:getInstance():showAlert(roadLayer,words.stage_already);
end

local function createArrow()
    local ret = CCSprite:create("new_quest/arrow.png")
    local seq = CCSequence:createWithTwoActions(CCMoveBy:create(0.7,ccp(0,5)),CCMoveBy:create(0.7,ccp(0,-5)));
    local acts = CCRepeatForever:create(seq);
    ret:runAction(acts);
    return ret;
end

--第几个关卡的内容
local function createStageByInfo(stageInfo, stageIdx)
    if stageIdx>0 and stageIdx<=stageNum then
        local stage = nil;
            --普通关卡
        if stageInfo[stageIdx]["sType"] == stageType["stage_normal"] then
            if curStage < stageIdx then 
                stage = CCMenuItemImage:create("cooking_road/btn_not.png","cooking_road/btn_not.png")
                stage:registerScriptTapHandler(MenuCallback_ClickStageNot);
            elseif curStage > stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_got.png","cooking_road/btn_got.png")
                stage:registerScriptTapHandler(MenuCallback_ClickStageGot);
            elseif curStage == stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_cur.png","cooking_road/btn_cur_s.png");
                stage:registerScriptTapHandler(MenuCallback_Fight)
            end
            --奖励关卡前的关卡
        elseif stageInfo[stageIdx]["sType"] == stageType["stage_boss"] then
            if curStage < stageIdx then 
                stage = CCMenuItemImage:create("cooking_road/btn_boss_d.png","cooking_road/btn_boss_d.png")
                stage:registerScriptTapHandler(MenuCallback_ClickStageNot);
            elseif curStage > stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_boss.png","cooking_road/btn_boss.png")
                stage:registerScriptTapHandler(MenuCallback_ClickStageGot);
            elseif curStage == stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_boss.png","cooking_road/btn_boss.png");
                stage:registerScriptTapHandler(MenuCallback_Fight)
            end
            --奖励关卡
        elseif stageInfo[stageIdx]["sType"] == stageType["stage_box_1"] then
            if curStage < stageIdx then 
                stage = CCMenuItemImage:create("cooking_road/btn_box_1_d.png","cooking_road/btn_box_1_d.png")
                stage:registerScriptTapHandler(MenuCallback_ClickBoxNot);
            elseif curStage > stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_box_1_opened.png","cooking_road/btn_box_1_opened.png")
                stage:registerScriptTapHandler(MenuCallback_ClickBoxGot);
            elseif curStage == stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_box_1.png","cooking_road/btn_box_1.png");
                stage:registerScriptTapHandler(MenuCallback_OpenBox)
            end
        elseif stageInfo[stageIdx]["sType"] == stageType["stage_box_2"] then
            if curStage < stageIdx then 
                stage = CCMenuItemImage:create("cooking_road/btn_box_2_d.png","cooking_road/btn_box_2_d.png")
                stage:registerScriptTapHandler(MenuCallback_ClickBoxNot);
            elseif curStage > stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_box_2_opened.png","cooking_road/btn_box_2_opened.png")
                stage:registerScriptTapHandler(MenuCallback_ClickBoxGot);
            elseif curStage == stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_box_2.png","cooking_road/btn_box_2.png");
                stage:registerScriptTapHandler(MenuCallback_OpenBox)
            end
        elseif stageInfo[stageIdx]["sType"] == stageType["stage_box_3"] then
            if curStage < stageIdx then 
                stage = CCMenuItemImage:create("cooking_road/btn_box_3_d.png","cooking_road/btn_box_3_d.png")
                stage:registerScriptTapHandler(MenuCallback_ClickBoxNot);
            elseif curStage > stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_box_3_opened.png","cooking_road/btn_box_3_opened.png")
                stage:registerScriptTapHandler(MenuCallback_ClickBoxGot);
                return stage;
            elseif curStage == stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_box_3.png","cooking_road/btn_box_3.png");
                stage:registerScriptTapHandler(MenuCallback_OpenBox)
            end
        elseif stageInfo[stageIdx]["sType"] == stageType["stage_box_4"] then
            if curStage < stageIdx then 
                stage = CCMenuItemImage:create("cooking_road/btn_box_4_d.png","cooking_road/btn_box_4_d.png")
                stage:registerScriptTapHandler(MenuCallback_ClickBoxNot);
            elseif curStage > stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_box_4_opened.png","cooking_road/btn_box_4_opened.png")
                stage:registerScriptTapHandler(MenuCallback_ClickBoxGot);
            elseif curStage == stageIdx then
                stage = CCMenuItemImage:create("cooking_road/btn_box_4.png","cooking_road/btn_box_4.png");
                stage:registerScriptTapHandler(MenuCallback_OpenBox)
            end
        end
        if stage then
            local pMenu = CCMenu:create();
            pMenu:setContentSize(stage:getContentSize());
            pMenu:setPosition(gCCPointZero);
            pMenu:addChild(stage);
            stage:setTag(stageInfo[stageIdx]["id"]);
            pMenu:setTouchPriority(roadLayerSettings["priority_btn"]);
            return pMenu; 
        end
    else
        print("error stageIdx:",stageIdx);
    end
end


--图片缩放后，图片上点的位置,posOri是在map上地坐标位置，左上角为原点
local function getPosAftScale(posOri,map)
    local pos = gCCPointZero;
    local tmpPos = ccp(posOri.x,heightOf(map) - posOri.y);
    if map then
        scaleX = map:getScaleX();
        scaleY = map:getScaleY();
        pos.x = scaleX * tmpPos.x;
        pos.y = scaleY * tmpPos.y;
    end
    if debugEnv() then
        print("tmpPos:",tmpPos.x,"   ",tmpPos.y)
        print("pos:",pos.x,"   ",pos.y)
    end
    return pos;
end

local lx;
local ly;
local function contrlPos(deltaX,deltaY)

    local rectContent = contentLayer:boundingBox();

    local posX
    local posY
    --屏幕右移动
    if deltaX>0 and rectContent:getMaxX() >= gWinSize.width and rectContent:getMinX()< 0 then
        posX = deltaX+posXof(contentLayer)
        if posX>=0 then posX = 0 end;
        contentLayer:setPositionX(posX)
    end
    --屏幕左移动
    if deltaX<0 and rectContent:getMaxX() > gWinSize.width and rectContent:getMinX()<= 0 then
        posX = deltaX+posXof(contentLayer)
        if posX+widthOf(contentLayer)<=gWinSize.width then posX = gWinSize.width-widthOf(contentLayer) end;
        contentLayer:setPositionX(posX)
    end
    --屏幕上移动
    if deltaY>0 and rectContent:getMaxY() >= gWinSize.height and rectContent:getMinY()<0 then
        posY = deltaY + posYof(contentLayer)
        if posY >= 0 then posY=0 end
        contentLayer:setPositionY(posY)
    end
    --屏幕下移动
    if deltaY<0 and rectContent:getMaxY() > gWinSize.height and rectContent:getMinY()<=0 then
        posY = deltaY + posYof(contentLayer)
        if posY + heightOf(contentLayer)<=gWinSize.height then posY=gWinSize.height-heightOf(contentLayer) end
        contentLayer:setPositionY(posY)
    end
end
local function touch_began(x,y)
    lx = x;
    ly = y;
    return true;
end

local function touch_moved(x,y)
    contrlPos(x-lx,y-ly);
    lx = x;
    ly = y;
end

local function touch_ended(x,y)

end
local function TouchCallback_touchRoad(event,x,y)
    if event == "began" then
        return touch_began(x,y)
    elseif event == "moved" then
        touch_moved(x,y)
    elseif event == "ended" then
        touch_ended(x,y)
    elseif event == "cancelled" then
    end
end
function initCookRoadView()
    if not stageLayer then return end;
    stageLayer:removeAllChildrenWithCleanup(true);
    local tmpStage = nil;
    local tmpPos = nil;
    for i=1,stageNum do
        tmpStage = createStageByInfo(stageInfo,i);
        tmpPos = getPosAftScale(stageInfo[i]["pos"], map);
        if tmpStage then
            tmpStage:setPosition(ccp(tmpPos.x + posXof(map)-widthOf(map)*0.5*map:getScaleX(),tmpPos.y + posYof(map) - heightOf(map)*0.5*map:getScaleY()));
            stageLayer:addChild(tmpStage);
            tmpStage:setTag(i);
        end
        if i == curStage then
            local arrow = createArrow()
            local test = widthOf(tmpStage)
            local pos = ccp(posXof(tmpStage),heightOf(tmpStage)+posYof(tmpStage))
            arrow:setPosition(pos)
            stageLayer:addChild(arrow);
            arrow:setZOrder(roadLayerSettings.zOrder_arrow);
        end
    end
end
local function MenuCallback_Close()
    if roadLayer then
        roadLayer:removeAllChildrenWithCleanup(true);
        roadLayer:removeFromParentAndCleanup(true);
        CCNotificationCenter:sharedNotificationCenter():postNotification(noticeMsg.MSG_NOTICE_TOUCH);
    end
    --curStage = nil;
    --contentLayer = nil;
    --stageLayer = nil;
    --roadLayer = nil;
    --roadLayerSettings =nil;
    --words = nil;
    --stageType = nil;
    --stageInfo = nil;
    --stageNum = nil;
    --tmpOkCallback = nil;
    --lx = nil;
    --ly = nil;
end
local function createFsLayer(closeCallback)
    local ret = CCLayer:create();

    local menu = CCMenu:create();
    menu:setTouchPriority(roadLayerSettings.priority_btn);
    menu:setPosition(ccp(0,0));
	ret:addChild(menu,200);

    btnClose = CCMenuItemImage:create("commBg/back.png","commBg/back.png");
    btnClose:setPosition(ccp(widthOf(btnClose)*0.5,gWinSize.height - heightOf(btnClose)*0.5));
    btnClose:registerScriptTapHandler(MenuCallback_Close)

    menu:addChild(btnClose);
    return ret;
end

function create(parent)
    if not parent then return end;
    roadLayer = createFsLayer(closeCallback);
    
    roadLayer:registerScriptTouchHandler(TouchCallback_touchRoad,false,roadLayerSettings["priority_roadLayer"],true);
    roadLayer:setTouchEnabled(true);
    parent:addChild(roadLayer,roadLayerSettings.zOrder_roadLayer);
    CCNotificationCenter:sharedNotificationCenter():postNotification(noticeMsg.MSG_NOTICE_NOTOUCH);
    map = CCSprite:create("cooking_road/bg.jpg");
    local scaleX = gWinSize.width / widthOf(map);
    local scaleY = gWinSize.height / heightOf(map);
    map:setScale(math.max(scaleX,scaleY));
    map:setPosition(ccp(widthOf(map)*0.5*map:getScaleX(),heightOf(map)*0.5*map:getScaleY()));
    
    contentLayer = CCLayer:create();
    roadLayer:addChild(contentLayer);
    contentLayer:addChild(map);
    contentLayer:setContentSize(CCSizeMake(map:getScaleX()*widthOf(map),map:getScaleY()*heightOf(map)));

    TopMenu:getInstance():showIn(roadLayer,true,false);

    local title = CCSprite:create("cooking_road/title.png")
    local titleBg = CCSprite:create("cooking_road/title_bg.png")

    titleBg:setPosition(ccp(gCenterX+40,gWinSize.height - heightOf(titleBg)*1.125+1));
    roadLayer:addChild(titleBg);
    title:setPosition(ccp(posXof(titleBg)-50,posYof(titleBg)+6));
    roadLayer:addChild(title);

    stageLayer = CCLayer:create();
    contentLayer:addChild(stageLayer);
    
    updateMap();
end






--endregion
